/*
    ViewWaveCmd.h - wave format file viewer

    Will Eighteen, 2005: will@opaline.demon.co.uk
*/

#ifndef VIEWWAVECMD_H
#define VIEWWAVECMD_H


#include <NoUndoCmd.h>
#include <GraphIntCmd.h>


class DMenuCmd;

class ViewWaveCmd : public NoUndoCmd
{
	protected:
		virtual void doCommand();	// ViewWave

	public:
		ViewWaveCmd ( const char *, int active = TRUE );
		virtual const char *const className() { return ( "ViewWaveCmd" ); }

	private:
		static void dMenuSelectionCallback ( void *, unsigned int, char * );
		static void viewWaveCmdCallback ( void *, void *, long, long, long,
											long, long, long, Boolean, unsigned, unsigned );
		static void waveDataCmdCallback ( void *, void *, long, long, long,
											long, long, long, Boolean, unsigned, unsigned );

		void viewWave ( unsigned int );
		void viewWaveCmdCallbackFinished ( GraphIntCmd *, long, long, long, long, long, long,
											Boolean, unsigned, unsigned );
		void createIntDataArray ( unsigned, long );

		long _currentSamples;
		unsigned _arrayItems;	// num items on menu
		Boolean _viewMenuRealised;
		DMenuCmd *_dMenu;
		char *_pData;
		Boolean allocDataBlock ( long );
		void freeDataBlock ( void );
};

#endif
